'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = objectMerge;

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function objectMerge(objA, objB) {
  var merged = {};
  (0, _keys2.default)(objA).forEach(function (key) {
    var a = objA[key];
    var b = objB[key];

    if (a === b) {
      merged[key] = a;
    } else if (!Array.isArray(a) && !Array.isArray(b) && (0, _isObject2.default)(a) && (0, _isObject2.default)(b)) {
      merged[key] = objectMerge(a, b);
    } else {
      merged[key] = b !== undefined ? b : a; // default to b if it exists
    }
  });

  (0, _keys2.default)(objB).forEach(function (key) {
    if (objA[key] === undefined) {
      // fill in the rest
      merged[key] = objB[key];
    }
  });

  return merged;
}